import { BaseApiClient } from "api";
import { Organization, ServicePortFilterItem, ServicePortSubscription } from "utils/types";

abstract class CustomApiClientInterface extends BaseApiClient {
    abstract portSubscriptions: (
        tagList?: string[],
        statusList?: string[],
        productList?: string[]
    ) => Promise<ServicePortSubscription[]>;
    abstract organisations: () => Promise<Organization[] | undefined>;
    abstract locationCodes: () => Promise<string[] | undefined>;
    abstract getPortSubscriptionsForNode: (id: string) => Promise<ServicePortFilterItem[]>;
}

export class CustomApiClient extends CustomApiClientInterface {
    portSubscriptions = (...[,,]): Promise<ServicePortSubscription[]> => {
        return this.fetchJson("non-existent-url");
    };

    organisations = async (): Promise<Organization[] | undefined> => {
        return undefined;
    };

    locationCodes = async (): Promise<string[] | undefined> => {
        return undefined;
    };

    getPortSubscriptionsForNode = (_: string): Promise<ServicePortFilterItem[]> => {
        return this.fetchJson("non-existent-url");
    };
}
